using Microsoft.AspNetCore.DataProtection;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;

namespace DataProtectionApiDemo.Pages;

public class ProtectModel : PageModel
{
    private readonly IDataProtectionProvider dataProtectionProvider;

    public ProtectModel(IDataProtectionProvider dataProtectionProvider )
    {
        this.dataProtectionProvider = dataProtectionProvider;
    }

    [BindProperty]
    public string? Text { get; set; }

    public string? ProtectedText { get; set; }

    public void OnPost()
    {
        var protector = this.dataProtectionProvider.CreateProtector("TestPS");
        var timeLimitedProtector = protector.ToTimeLimitedDataProtector();
        this.ProtectedText = timeLimitedProtector.Protect(this.Text ?? string.Empty, TimeSpan.FromSeconds(60));
    }

}
