using Microsoft.AspNetCore.DataProtection;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;

namespace DataProtectionApiDemo.Pages;

public class UnprotectModel : PageModel
{
    private readonly IDataProtectionProvider dataProtectionProvider;

    public UnprotectModel(IDataProtectionProvider dataProtectionProvider)
    {
        this.dataProtectionProvider = dataProtectionProvider;
    }

    [BindProperty]
    public string? ProtectedText { get; set; }

    public string? Text { get; set; }

    public void OnPost()
    {
        var protector = this.dataProtectionProvider.CreateProtector("TestPS");
        var timeLimitedProtector = protector.ToTimeLimitedDataProtector();
        this.Text = timeLimitedProtector.Unprotect(this.ProtectedText ?? string.Empty);
    }
}
