using Microsoft.AspNetCore.DataProtection;

var builder = WebApplication.CreateBuilder(args);

// Add services to the container.
var keyFolder = Path.Combine(builder.Environment.ContentRootPath, "DataProtectionKeys");
#pragma warning disable CA1416 // Validate platform compatibility
builder.Services.AddDataProtection()
    .PersistKeysToFileSystem(new DirectoryInfo(keyFolder))
    .SetDefaultKeyLifetime(TimeSpan.FromDays(30))
    .ProtectKeysWithDpapi();
#pragma warning restore CA1416 // Validate platform compatibility
builder.Services.AddRazorPages();

var app = builder.Build();

// Configure the HTTP request pipeline.
if (!app.Environment.IsDevelopment())
{
    app.UseExceptionHandler("/Error");
}

app.UseStaticFiles();

app.UseRouting();

app.UseAuthorization();

app.MapRazorPages();

app.Run();
